HDU - 1595 find the longest of the shortest(最短路Dijkstra+枚举删边)

时间:2022-05-01 22:07:58


Time Limit: 5000MS   Memory Limit: 32768KB   64bit IO Format: %I64d & %I64u

Status

Description

Marica is very angry with Mirko because he found a new girlfriend and she seeks revenge.Since she doesn't live in the same city, she started preparing for the long journey.We know for every road how many minutes it takes to come from one city to another.
Mirko overheard in the car that one of the roads is under repairs, and that it is blocked, but didn't konw exactly which road. It is possible to come from Marica's city to Mirko's no matter which road is closed.
Marica will travel only by non-blocked roads, and she will travel by shortest route. Mirko wants to know how long will it take for her to get to his city in the worst case, so that he could make sure that his girlfriend is out of town for long enough.Write a program that helps Mirko in finding out what is the longest time in minutes it could take for Marica to come by shortest route by non-blocked roads to his city.
 

Input

Each case there are two numbers in the first row, N and M, separated by a single space, the number of towns,and the number of roads between the towns. 1 ≤ N ≤ 1000, 1 ≤ M ≤ N*(N-1)/2. The cities are markedwith numbers from 1 to N, Mirko is located in city 1, and Marica in city N.
In the next M lines are three numbers A, B and V, separated by commas. 1 ≤ A,B ≤ N, 1 ≤ V ≤ 1000.Those numbers mean that there is a two-way road between cities A and B, and that it is crossable in V minutes.
 

Output

In the first line of the output file write the maximum time in minutes, it could take Marica to come to Mirko.
 

Sample Input

 
   
5 6 1 2 4 1 3 3 2 3 1 2 4 4 2 5 7 4 5 1 6 7 1 2 1 2 3 4 3 4 4 4 6 4 1 5 5 2 5 2 5 6 5 5 7 1 2 8 1 4 10 2 3 9 2 4 10 2 5 1 3 4 7 3 5 10
 

Sample Output

 
   
11 13 27
 

Source

HDU 2007-Spring Programming Contest - Warm Up (1)


题意:某人要从 1 号城市到 n 号城市。有一条最短路径,在这条路径上可能会有一条边在维修,问此时从1~n的最短路径可能的最大值。读起来略拗口。慢慢理解就是了,不难懂。

思路:先用最短路径保存路径,以及 dist[n]。最后在这条最短路径上枚举删除边,做一个最短路,维护最大的dist[n] 值就可以了。


<span style="font-size:18px;">#include <cstdio>
#include <iostream>
#include <cstring>
#include <cmath>
#include <string>
#include <algorithm>
#include <queue>
#include <stack>
using namespace std;

const double PI = acos(-1.0);
const double e = 2.718281828459;
const double eps = 1e-8;
const int MAXN = 1010;
const int INF = 1<<29;
int dist[MAXN];
int map[MAXN][MAXN];
int pre[MAXN];
int vis[MAXN];
int n, m;

void Dijkstra(int f)  // 模板,照敲就可以
{
    for(int i = 1; i <= n; i++)
    {
        dist[i] = map[1][i];
    }
    memset(vis, 0, sizeof(vis));
    dist[1] = 0;
    for(int i = 1; i <= n-1; i++)
    {
        int u = 1;
        int t = INF;
        for(int j = 1; j <= n; j++)
        {
            if(!vis[j] && dist[j]<t)
            {
                u = j;
                t = dist[j];
            }
        }
        vis[u] = 1;
        for(int j = 1; j <= n; j++)
        {
            if(!vis[j] && map[u][j]!=INF && dist[j]>dist[u]+map[u][j])
            {
                dist[j] = dist[u]+map[u][j];
                if(f) // 若 f 为 0 表示不用重设路径
                    {
                        pre[j] = u;
                        //printf("p[%d] = %d   d = %d\n", j, u, dist[j] );
                    }
            }
        }
    }
}

int main()
{
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    while(cin>>n>>m)
    {
        for(int i = 1; i <= n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                map[i][j] = (i==j)?0:INF;
            }
        }
        int u, v, w;
        for(int i = 1; i <= m; i++)
        {
            scanf("%d %d %d", &u, &v, &w);
            if(map[u][v] > w)
                map[u][v] = map[v][u] = w;  // 可能会有重边
        }
        for(int i = 1; i <= n; i++)
            pre[i] = 1;      // 记得初始化路径,把每个点的父节点都设为 1 , WA了都是泪啊!!
        Dijkstra(1);
        int maxv = dist[n];
        for(int i = n; i != 1; i = pre[i])  // 在最短路径上枚举删边
        {
            u = i;
            v = pre[i];
            int t = map[u][v];
            map[u][v] = map[v][u] = INF;
            Dijkstra(0);  // 0 表示不用再重置路径
            if(maxv < dist[n])
                maxv = dist[n];
            map[u][v] = map[v][u] = t;  // 还原边值
        }
        printf("%d\n", maxv);
    }
    return 0;
}

</span>